unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    ListBox1: TListBox;
    ListBox2: TListBox;
    Image1: TImage;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  topen,tclose,move:boolean;
  lastindex:integer;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
     form1.Close;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
     if ((mouse.CursorPos.y=0) and (mouse.CursorPos.X>=form1.Left) and (mouse.CursorPos.X<=form1.Left+form1.Width))
        and (form1.Top=0-form1.Height) and (move<>true) then
     begin
          topen:=true;
          move:=true;
     end;
     if (mouse.CursorPos.y>0+form1.Height) and (form1.Top=0) and (move<>true) then
     begin
          tclose:=true;
          move:=true;
     end;
     if (topen) then
     begin
          if form1.Top<0 then
               form1.Top:=form1.Top+14
          else
          begin
               form1.Top:=0;
               topen:=false;
               move:=false;
          end;
     end;
     if (tclose) then
     begin
          if form1.Top>0-form1.Height then
               form1.Top:=form1.Top-14
          else
          begin
               form1.Top:=0-form1.Height;;
               tclose:=false;
               move:=false;
          end;
     end;
     form1.Repaint;
     form1.ListBox1.Repaint;
     form1.ListBox2.Repaint;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     form1.Left:=screen.Width div 2 - form1.Width div 2;
     form1.Top:=0-form1.Height;
     topen:=false;
     tclose:=false;
     move:=false;
     if form1.ListBox1.Items.Text='' then
     begin
          form1.SpeedButton2.Enabled:=false;
          form1.SpeedButton4.Enabled:=false;
     end;
     if form1.ListBox2.Items.Text='' then
     begin
          form1.SpeedButton3.Enabled:=false;
          form1.SpeedButton5.Enabled:=false;
     end;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
     form1.Close;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
     if form1.ListBox1.ItemIndex=-1 then
          form1.ListBox1.ItemIndex:=0;
     lastindex:=form1.ListBox1.ItemIndex;
     form1.ListBox2.Items.Append(form1.ListBox1.Items.Strings[form1.ListBox1.itemindex]);
     form1.ListBox1.Items.Delete(form1.ListBox1.itemindex);
     form1.ListBox1.ItemIndex:=lastindex;
     if form1.ListBox1.Items.Text='' then
     begin
          form1.SpeedButton2.Enabled:=false;
          form1.SpeedButton4.Enabled:=false;
     end
     else
     begin
          form1.SpeedButton2.Enabled:=true;
          form1.SpeedButton3.Enabled:=true;
          form1.SpeedButton4.Enabled:=true;
          form1.SpeedButton5.Enabled:=true;
     end;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
     if form1.ListBox2.ItemIndex=-1 then
          form1.ListBox2.ItemIndex:=0;
     lastindex:=form1.ListBox2.ItemIndex;
     form1.ListBox1.Items.Append(form1.ListBox2.Items.Strings[form1.ListBox2.itemindex]);
     form1.ListBox2.Items.Delete(form1.ListBox2.itemindex);
     form1.ListBox2.ItemIndex:=lastindex;
     if form1.ListBox2.Items.Text='' then
     begin
          form1.SpeedButton3.Enabled:=false;
          form1.SpeedButton5.Enabled:=false;
     end
     else
     begin
          form1.SpeedButton2.Enabled:=true;
          form1.SpeedButton3.Enabled:=true;
          form1.SpeedButton4.Enabled:=true;
          form1.SpeedButton5.Enabled:=true;
     end
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
     form1.ListBox2.Items.AddStrings(form1.ListBox1.Items);
     form1.ListBox1.Clear;
     form1.SpeedButton2.Enabled:=false;
     form1.SpeedButton3.Enabled:=true;
     form1.SpeedButton4.Enabled:=false;
     form1.SpeedButton5.Enabled:=true;
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
     form1.ListBox1.Items.AddStrings(form1.ListBox2.Items);
     form1.ListBox2.Clear;
     form1.SpeedButton2.Enabled:=true;
     form1.SpeedButton3.Enabled:=false;
     form1.SpeedButton4.Enabled:=true;
     form1.SpeedButton5.Enabled:=false;
end;

end.
